<template>
  <div class="timeline">
    <div
      class="entry"
      v-for="(e, i) in events"
      :key="e.date">
      <div class="time-ball justify-stretch">
        <div :class="i === 0 ? ['h-full', 'lg:w-full'] : ['bg-blue-700', 'w-2', 'h-full', 'lg:w-full', 'lg:h-2']"></div>
        <div :class="ballClasses(e.date)">
          <div class="text-sm">{{ e.date.day }}</div>
          <div class="text-sm">{{ e.date.month }}</div>
        </div>
        <div :id="i" :class="i+1 === events.length ? ['h-full', 'lg:w-full'] : ['bg-blue-700', 'w-2', 'h-full', 'lg:w-full', 'lg:h-2']"></div>
      </div>
      <div class="text">
        {{ e.text }}
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component';

export interface ITimelineEvent {
  date: {
    day: string;
    month: string;
    year: string;
  }
  text: string;
}

@Component({
  props: {
    events: {
      type: Array,
      required: true,
      validator: (value: any): boolean => {
        return value instanceof Array
            && value.length > 0
            && value
                .reduce((acc: boolean, curr: any): boolean => {
                  return acc && curr.date && curr.text;
                }, true);
      },
    }
  }
})
export default class Timeline extends Vue {
  ballClasses(date: any): string[] {
    const base: string[] = ['ball-date'];
    
    const pastClasses: string[] = [
      'text-blue-700',
      'italic',
      'bg-transparent',
      'border-dashed',
      'border-blue-700',
      ''
    ];

    const currentClasses: string[] = [
      'font-bold',
      'bg-white',
    ];

    const futureClasses: string[] = [
      'bg-blue-700',
      'text-gray-100'
    ];


    const monthMapper: any = {
      JAN: 0, FEV: 1, MAR: 2, ABR: 3,
      MAI: 4, JUN: 5, JUL: 6, AGO: 7,
      SET: 8, OUT: 9, NOV: 10, DEZ: 11,
    };

    const today: Date = new Date();
    const eventDate: Date = new Date(date.year, monthMapper[date.month], date.day, today.getHours(), today.getMinutes(), today.getSeconds(), today.getMilliseconds());
    const timeDiff: number = Number(today.getTime() - eventDate.getTime());

    if (timeDiff === 0) {
      base.push(...currentClasses);
    } else if (timeDiff < 0) {
      base.push(...futureClasses);
    } else {
      base.push(...pastClasses);
    }

    return base;
  }
}
</script>

<style lang="postcss" scoped>
.timeline {
  @apply w-full p-4;
  @apply flex flex-col justify-start items-center;
}

.entry {
  @apply w-full px-2;
  @apply flex flex-row justify-start items-stretch;
}

.entry > .time-ball {
  @apply mx-2;
  @apply flex flex-col items-center;
}

.ball-date {
  @apply w-12 py-2 border-2 border-blue-700;
  @apply flex flex-col items-center justify-center;
  @apply rounded-full;
}

.entry > .text {
  @apply mx-2 py-3;
  @apply flex flex-row justify-start items-center;
}

@screen md {
  .timeline {
    @apply items-start;
  }

  .ball-date {
    @apply my-4;
  }
}

@screen lg {
  .timeline {
    @apply flex-row;
  }

  .entry {
    @apply px-0;
    @apply flex-col;
  }

  .entry > .time-ball {
    @apply mx-0;
    @apply flex-row;
  }

  .entry > .text {
    @apply px-2;
    @apply text-center;
  }

  .ball-date {
    @apply w-32;
  }
}
</style>
